Package com.io7m.jtensors.core.unparameterized.vectors

# Class Vector2F

java.lang.Object
com.io7m.jtensors.core.unparameterized.vectors.Vector2F

All Implemented Interfaces:
  `Vector2FType`, `VectorReadable2FType`, `VectorComputationalType`

public final class Vector2F extends Object implements Vector2FType
The type of 2D `float`-typed vectors.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `Vector2F.Builder`
  Builds instances of type `Vector2F`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Vector2F.Builder`
  `builder()`
  Creates a builder for `Vector2F`.
  `static Vector2F`
  `copyOf(Vector2FType instance)`
  Creates an immutable copy of a `Vector2FType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `Vector2F` that have equal attribute values.
  `int`
  `hashCode()`
  Computes a hash code from attributes: `x`, `y`.
  `static Vector2F`
  `of(float x, float y)`
  Construct a new immutable `Vector2F` instance.
  `String`
  `toString()`
  Prints the immutable value `Vector2F` with attribute values.
  `final Vector2F`
  `withX(float value)`
  Copy the current immutable object by setting a value for the `x` attribute.
  `final Vector2F`
  `withY(float value)`
  Copy the current immutable object by setting a value for the `y` attribute.
  `float`
  `x()`
  `float`
  `y()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### x

    public float x()
    Specified by:
      `x` in interface `Vector2FType`
    Specified by:
      `x` in interface `VectorReadable2FType`
    Returns:
      The value of the `x` attribute

  - ### y

    public float y()
    Specified by:
      `y` in interface `Vector2FType`
    Specified by:
      `y` in interface `VectorReadable2FType`
    Returns:
      The value of the `y` attribute

  - ### withX

    public final Vector2F withX(float value)
    Copy the current immutable object by setting a value for the `x` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for x
    Returns:
      A modified copy of the `this` object

  - ### withY

    public final Vector2F withY(float value)
    Copy the current immutable object by setting a value for the `y` attribute. A value strict bits equality used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for y
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `Vector2F` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `x`, `y`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `Vector2F` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static Vector2F of(float x, float y)
    Construct a new immutable `Vector2F` instance.
    Parameters:
      `x` - The value for the `x` attribute
      `y` - The value for the `y` attribute
    Returns:
      An immutable Vector2F instance

  - ### copyOf

    public static Vector2F copyOf(Vector2FType instance)
    Creates an immutable copy of a `Vector2FType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable Vector2F instance

  - ### builder

    public static Vector2F.Builder builder()
    Creates a builder for `Vector2F`.

         Vector2F.builder()
            .setX(float) // required x
            .setY(float) // required y
            .build();

    Returns:
      A new Vector2F builder